import { Task } from './Task';
import { TaskOptions } from './TaskOptions';
import { TaskFunction } from './TaskFunction';
import { QueueOptions } from './QueueOptions';
export declare class Queue<T, R> {
    taskPointer: number;
    gcThreshold: number;
    taskTimeout?: number;
    isIdle: boolean;
    tasks: Task<any, any>[];
    taskFunction?: TaskFunction<T, R>;
    constructor(options?: QueueOptions);
    setTaskFunction(input: TaskFunction<T, R>): this;
    deleteTaskFunction(): this;
    getNextTask(): Task<any, any> | undefined;
    hasTasks(): boolean;
    gc(): this;
    startLoop(): Promise<void>;
    addTaskData(taskData: T, options?: TaskOptions): Promise<R> | void;
    addTask<RR>(taskFunction: TaskFunction<any, RR>, options?: TaskOptions): Promise<RR> | void;
}
